package com.steerinfo.pretrack.prestoragescale.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.pretrack.prestoragescale.model.PreStorageScale;
import com.steerinfo.pretrack.prestoragescale.service.IPreStorageScaleService;
import com.steerinfo.util.StringUtils;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * PreStorageScale RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-09-24 10:55
 * 类描述
 * 修订历史：
 * 日期：2021-09-24
 * 作者：generator
 * 参考：
 * 描述：PreStorageScale RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/prestoragescales")
public class PreStorageScaleController extends BaseRESTfulController {

    @Autowired
    IPreStorageScaleService preStorageScaleService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("prestoragescale:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<PreStorageScale> list = preStorageScaleService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("prestoragescale:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<PreStorageScale> list = preStorageScaleService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据PreStorageScale对象创建")
    @ApiImplicitParam(name = "preStorageScale", value = "详细实体preStorageScale", required = true, dataType = "PreStorageScale")
    //@RequiresPermissions("prestoragescale:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute PreStorageScale model){
        PreStorageScale preStorageScale = preStorageScaleService.add(model);
        return success(preStorageScale);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("prestoragescale:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        PreStorageScale preStorageScale = preStorageScaleService.getById(id);
        return success(preStorageScale);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的preStorageScale信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "preStorageScale", value = "详细实体preStorageScale", required = true, dataType = "PreStorageScale")
    })
    //@RequiresPermissions("prestoragescale:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody PreStorageScale model){
        model.setId(id);
        PreStorageScale preStorageScale = preStorageScaleService.modify(model);
        return success(preStorageScale);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("prestoragescale:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  preStorageScaleService.delete(ids);
    	}
      return success();
    }

    @ApiOperation(value = "批量新增数据", notes = "界面填写数据，服务端做二次校验及赋值")
    @Transactional(rollbackFor = {MarkerMetException.class, Exception.class})
    @PostMapping(value = "/doAddWf")
    public RESTfulResult doAddWf(@RequestBody List<PreStorageScale> models) {
        RESTfulResult rm = failed();
        try {
            String str = preStorageScaleService.doAddWf(models);
            if (StringUtils.isEmpty(str)) {
                return success();
            } else {
                return failed("操作失败!" + str);
            }
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
            rm.setData(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！"+e.getMessage());
            rm.setData("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value = "批量修改数据", notes = "界面填写数据，服务端做二次校验及赋值")
    @Transactional(rollbackFor = {MarkerMetException.class, Exception.class})
    @PostMapping(value = "/doUpdateWf")
    public RESTfulResult doUpdateWf(@RequestBody List<PreStorageScale> models) {
        RESTfulResult rm = failed();
        try {
            String str = preStorageScaleService.doUpdateWf(models);
            if (StringUtils.isEmpty(str)) {
                return success();
            } else {
                return failed("操作失败!" + str);
            }
        }catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
            rm.setData(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！"+e.getMessage());
            rm.setData("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

}
